C
C
C
      SUBROUTINE   WMSGTI
     I                   (WDMSFL,SCLU,SGRP,ID,ORDER,
     O                    OLEN,TBUFF)
C
C     + + + PURPOSE + + +
C     Return a text buffer containing the message file
C     information for the given ID and ORDER numbers.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   WDMSFL,SCLU,SGRP,ID,ORDER,OLEN
      CHARACTER*1 TBUFF(*)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number for WDM file
C     SCLU   - data-set number on WDM file
C     SGRP   - group number in data set
C     ID     - identification of information
C     ORDER  - order number of information to retrieve
C     OLEN   - length of output text buffer (0 if info not found)
C     OBUFF  - output text buffer
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I,CLASS,LID,LORDER,TLEN,ILEN,IMATCH,
     $           DREC,DPOS,DIND,BCWORD,RDWRFG,GLEN,MLEN,CONT
C
C     + + + INTRINSICS + + +
      INTRINSIC  MOD
C
C     + + + EXTERNALS + + +
      EXTERNAL   WMSFBC, WMSBCS, WDNXPS, WDNXDV, WMSGTE
C
C     + + + END SPECIFICATIONS + + +
C
      RDWRFG= 1
      IMATCH= 0
C     get first block control word for group
      CALL WMSFBC (WDMSFL,SCLU,SGRP,
     O             DREC,DPOS,BCWORD)
C
 10   CONTINUE
C       look through group for matching ids
        IF (BCWORD.EQ.0) THEN
C         ids never matched or bad group
          OLEN  = 0
          IMATCH= -1
        ELSE
C         split block control word
          CALL WMSBCS (BCWORD,
     O                 CLASS,LID,ORDER,TLEN)
C         do ids match
          IF (LID.EQ.ID .AND. LORDER.EQ.ORDER) THEN
C           ids and orders match, return record and position
            IMATCH= 1
C           now retrieve the info
            GLEN= 0
            MLEN= 0
 20         CONTINUE
C             get lines of text until cont is 0
              CALL WMSGTE (WDMSFL,TLEN,TLEN,
     M                     DREC,DPOS,GLEN,MLEN,
     O                     OLEN,OBUFF,CONT)
            IF (CONT.EQ.1) GO TO 20
          ELSE
C           ids dont match, skip to next BCWORD
            ILEN= TLEN/4
            IF (MOD(TLEN,4).NE.0) THEN
C             one more value to skip
              ILEN= ILEN+ 1
            END IF
            DO 100 I= 1,ILEN
              CALL WDNXPS (WDMSFL,RDWRFG,
     M                     DREC,DPOS,
     O                     DIND)
 100        CONTINUE
C           get the next block control word
            CALL WDNXDV (WDMSFL,
     M                   DREC,DPOS,
     O                   BCWORD)
          END IF
        END IF
      IF (IMATCH.EQ.0) GO TO 10
C
      RETURN
      END
