C     qtprin.f 2.1 9/4/91
C
C
C
      SUBROUTINE   PRNTXT
     I                    (UMESFL,SCLU,SGRP)
C
C     + + + PURPOSE + + +
C     This routine prints text from a message file to a terminal.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   UMESFL,SCLU,SGRP
C
C     + + + ARGUMENT DEFINITIONS + + +
C     UMESFL - message file containing text to print
C     SCLU   - screen cluster number on WDM-message file
C     SGRP   - screen group number in cluster
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   MAXLIN,SCNINI
C
C     + + + EXTERNALS + + +
      EXTERNAL   PMXTXT
C
      MAXLIN= 20
      SCNINI= 0
C
      CALL PMXTXT (UMESFL,SCLU,SGRP,MAXLIN,SCNINI)
C
      RETURN
      END
C
C
C
      SUBROUTINE   PMXTXT
     I                    (UMESFL,SCLU,SGRP,MAXLIN,SCNINI)
C
C     + + + PURPOSE + + +
C     This routine prints text from a message file to a terminal.
C     It prompts the user every MAXLIN lines to be sure its ok
C     to continue.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   UMESFL,SCLU,SGRP,MAXLIN,SCNINI
C
C     + + + ARGUMENT DEFINITIONS + + +
C     UMESFL - message file containing text to print
C     SCLU   - screen cluster number on WDM-message file
C     SGRP   - screen group number in cluster
C     MAXLIN - maximum number of lines to print before more prompt
C     SCNINI - screen initialization flag (-1 - dont clear anything,
C                                           0 - clear in EMIFE mode only
C                                           1 - always clear)
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   LINCNT
C
C     + + + EXTERNALS + + +
      EXTERNAL   PMXCNT
C
C     + + + END SPECIFICATIONS + + +
C
      CALL PMXCNT (UMESFL,SCLU,SGRP,MAXLIN,SCNINI,
     O             LINCNT)
C
      RETURN
      END
C
C
C
      SUBROUTINE   PRTXLC
     I                    (UMESFL,SCLU,SGRP,
     O                     LINCNT)
C
C     + + + PURPOSE + + +
C     This routine prints text from a message file to a terminal.
C     It also returns LINCNT, the number of lines printed.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   UMESFL,SCLU,SGRP,LINCNT
C
C     + + + ARGUMENT DEFINITIONS + + +
C     UMESFL - message file containing text to print
C     SCLU   - screen cluster number on WDM-message file
C     SGRP   - screen group number in cluster
C     LINCNT - count of lines printed
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   MAXLIN,SCNINI
C
C     + + + EXTERNALS + + +
      EXTERNAL   PMXCNT
C
C     + + + END SPECIFICATIONS + + +
C
      MAXLIN= 20
      SCNINI= 0
C
      CALL PMXCNT (UMESFL,SCLU,SGRP,MAXLIN,SCNINI,
     O             LINCNT)
C
      RETURN
      END
C
C
C
      SUBROUTINE   PMXCNT
     I                    (UMESFL,SCLU,SGRP,MAXLIN,SCNINI,
     O                     LINCNT)
C
C     + + + PURPOSE + + +
C     This routine prints text from a message file to a terminal.
C     It prompts the user every MAXLIN lines to be sure its ok
C     to continue.  It also returns the number of lines printed.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   UMESFL,SCLU,SGRP,MAXLIN,SCNINI,LINCNT
C
C     + + + ARGUMENT DEFINITIONS + + +
C     UMESFL - message file containing text to print
C     SCLU   - screen cluster number on WDM-message file
C     SGRP   - screen group number in cluster
C     MAXLIN - maximum number of lines to print before more prompt
C     SCNINI - screen initialization flag (-1 - dont clear anything,
C                                           0 - clear in EMIFE mode only
C                                           1 - always clear)
C     LINCNT - count of lines printed
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   IWRT
C
C     + + + EXTERNALS + + +
      EXTERNAL  PMXCNW
C
C     + + + END SPECIFICATIONS + + +
C
      IWRT= 0
C
      CALL PMXCNW (UMESFL,SCLU,SGRP,MAXLIN,SCNINI,IWRT,
     O             LINCNT)
C
      RETURN
      END
C
C
C
      SUBROUTINE   PMXCNW
     I                    (UMESFL,SCLU,SGRP,MAXLIN,SCNINI,IWRT,
     O                     LINCNT)
C
C     + + + PURPOSE + + +
C     This routine prints text from a message file to a terminal.
C     It prompts the user every MAXLIN lines to be sure its ok
C     to continue.  It also returns the number of lines printed.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   UMESFL,SCLU,SGRP,MAXLIN,SCNINI,IWRT,LINCNT
C
C     + + + ARGUMENT DEFINITIONS + + +
C     UMESFL - message file containing text to print
C     SCLU   - screen cluster number on WDM-message file
C     SGRP   - screen group number in cluster
C     MAXLIN - maximum number of lines to print before more prompt
C     SCNINI - screen initialization flag (-1 - dont clear anything,
C                                           0 - clear in EMIFE mode only
C                                           1 - always clear)
C     IWRT   - 1 - write and go, 0 - write and wait for user acknowledge
C             -1 - dont write yet (EMIFE only)
C     LINCNT - count of lines printed
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     CONT,INITFG,DONFG,OLEN,LINIT,LWRT
      CHARACTER*1 TXT(78)
C
C     + + + EXTERNALS + + +
      EXTERNAL    ZBLDWR, WMSGTT, ZTXINI
C
C     + + + END SPECIFICATIONS + + +
C
      LINCNT= 0
      DONFG = 0
C
      IF (SCNINI.GE.0) THEN
C       initialize the menu for EMIFE screen
        LINIT= 1
        CALL ZTXINI
      ELSE
C       dont initialize menu for EMIFE
        LINIT= 0
      END IF
C
      INITFG= 1
 10   CONTINUE
C       get next record of text
        OLEN= 78
        CALL WMSGTT (UMESFL,SCLU,SGRP,INITFG,
     M               OLEN,
     O               TXT,CONT)
        INITFG= 0
C
        LINCNT= LINCNT+ 1
C       build output screen (EMIFE style)
        IF (CONT.EQ.1) THEN
C         building screen
          LWRT= -1
        ELSE
C         screen complete
          LWRT= IWRT
        END IF
        CALL ZBLDWR (OLEN,TXT,LINIT,LWRT,
     O               DONFG)
        IF (DONFG.NE.0) THEN
C         completed screen, initialize next time through
          LINIT= 1
        ELSE
C         dont initialize next time through
          LINIT= 0
        END IF
C
      IF (DONFG.LE.1 .AND. CONT.EQ.1) GO TO 10
C
      RETURN
      END
C
C
C
      SUBROUTINE   PRNTXI
     I                    (UMESFL,SCLU,SGRP,IVAL)
C
C     + + + PURPOSE + + +
C     This routine prints text from a message file to a terminal with
C     an integer value appended to the end of the first line.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   UMESFL,SCLU,SGRP,IVAL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     UMESFL - message file containing text to print
C     SCLU   - screen cluster number on WDM-message file
C     SGRP   - screen group number in cluster
C     IVAL   - integer value to append at end of first line
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   MAXLIN,SCNINI,IWRT,INUM,IIVAL(1)
C
C     + + + EXTERNALS + + +
      EXTERNAL   PMXTXI
C
      MAXLIN  = 20
      SCNINI  = 0
      INUM    = 1
      IIVAL(1)= IVAL
      IWRT    = 0
C
      CALL PMXTXI (UMESFL,SCLU,SGRP,MAXLIN,SCNINI,IWRT,INUM,IIVAL)
C
      RETURN
      END
C
C
C
      SUBROUTINE   PMXTXI
     I                  (UMESFL,SCLU,SGRP,MAXLIN,SCNINI,IWRT,INUM,IVAL)
C
C     + + + PURPOSE + + +
C     This routine prints text from a message file to a terminal.
C     It fills in values from IVAL whenever delimeter is found.
C     It prompts the user every MAXLIN lines to be sure its ok
C     to continue.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   UMESFL,SCLU,SGRP,MAXLIN,SCNINI,IWRT,INUM,IVAL(INUM)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     UMESFL - message file containing text to print
C     SCLU   - screen cluster number on WDM-message file
C     SGRP   - screen group number in cluster
C     MAXLIN - maximum number of lines to print before more prompt
C     SCNINI - screen initialization flag (-1 - dont clear anything,
C                                           0 - clear in EMIFE mode only
C                                           1 - always clear)
C     IWRT   - 1 - write and go, 0 - write and wait for user acknowledge
C             -1 - dont write yet (EMIFE only)
C     INUM   - number of integers to include in message
C     IVAL   - array containing integers to include
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I,ONUM,OTYP(50),CLEN(1)
      REAL        RVAL(1)
      DOUBLE PRECISION DVAL(1)
      CHARACTER*1 CVAL(1)
C
C     + + + EXTERNALS + + +
      EXTERNAL   PMXTXM
C
C     + + + END SPECIFICATIONS + + +
C
      RVAL(1)= -999.
      DVAL(1)= -999.
      CLEN(1)= 1
      CVAL(1)= ' '
      ONUM   = INUM
      DO 10 I= 1,ONUM
        OTYP(I)= 1
 10   CONTINUE
C
      CALL PMXTXM (UMESFL,SCLU,SGRP,MAXLIN,SCNINI,ONUM,OTYP,IWRT,
     I             IVAL,RVAL,DVAL,CLEN,CVAL)
C
      RETURN
      END
C
C
C
      SUBROUTINE   PRNTXR
     I                    (UMESFL,SCLU,SGRP,RVAL)
C
C     + + + PURPOSE + + +
C     This routine prints text from a message file to a terminal with
C     an decimal value appended to the end of the first line.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   UMESFL,SCLU,SGRP
      REAL      RVAL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     UMESFL - message file containing text to print
C     SCLU   - screen cluster number on WDM-message file
C     SGRP   - screen group number in cluster
C     RVAL   - array containing decimals to include
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   MAXLIN,SCNINI,RNUM,IWRT
      REAL      RRVAL(1)
C
C     + + + EXTERNALS + + +
      EXTERNAL   PMXTXR
C
      MAXLIN  = 20
      SCNINI  = 0
      RNUM    = 1
      RRVAL(1)= RVAL
      IWRT    = 0
C
      CALL PMXTXR (UMESFL,SCLU,SGRP,MAXLIN,SCNINI,IWRT,RNUM,RRVAL)
C
      RETURN
      END
C
C
C
      SUBROUTINE   PMXTXR
     I                  (UMESFL,SCLU,SGRP,MAXLIN,SCNINI,IWRT,RNUM,RVAL)
C
C     + + + PURPOSE + + +
C     This routine prints text from a message file to a terminal.
C     It fills in values from RVAL whenever delimeter is found.
C     It prompts the user every MAXLIN lines to be sure its ok
C     to continue.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   UMESFL,SCLU,SGRP,MAXLIN,SCNINI,IWRT,RNUM
      REAL      RVAL(RNUM)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     UMESFL - message file containing text to print
C     SCLU   - screen cluster number on WDM-message file
C     SGRP   - screen group number in cluster
C     MAXLIN - maximum number of lines to print before more prompt
C     SCNINI - screen initialization flag (-1 - dont clear anything,
C                                           0 - clear in EMIFE mode only
C                                           1 - always clear)
C     IWRT   - 1 - write and go, 0 - write and wait for user acknowledge
C             -1 - dont write yet (EMIFE only)
C     RNUM   - number of decimal numbers to include in message
C     RVAL   - array containing numbers to include
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I,ONUM,OTYP(50),IVAL(1),CLEN(1)
      DOUBLE PRECISION DVAL(1)
      CHARACTER*1 CVAL(1)
C
C     + + + EXTERNALS + + +
      EXTERNAL   PMXTXM
C
C     + + + END SPECIFICATIONS + + +
C
      IVAL(1)= -999
      DVAL(1)= -999.
      CLEN(1)= 1
      CVAL(1)= ' '
      ONUM   = RNUM
      DO 10 I= 1,ONUM
        OTYP(I)= 2
 10   CONTINUE
C
      CALL PMXTXM (UMESFL,SCLU,SGRP,MAXLIN,SCNINI,ONUM,OTYP,IWRT,
     I             IVAL,RVAL,DVAL,CLEN,CVAL)
C
      RETURN
      END
C
C
C
      SUBROUTINE   PRNTXD
     I                    (UMESFL,SCLU,SGRP,DVAL)
C
C     + + + PURPOSE + + +
C     This routine prints text from a message file to a terminal with
C     a double precision value appended to the end of the first line.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER          UMESFL,SCLU,SGRP
      DOUBLE PRECISION DVAL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     UMESFL - message file containing text to print
C     SCLU   - screen cluster number on WDM-message file
C     SGRP   - screen group number in cluster
C     DVAL   - array containing decimals to include
C
C     + + + LOCAL VARIABLES + + +
      INTEGER          MAXLIN,SCNINI,DNUM,IWRT
      DOUBLE PRECISION DDVAL(1)
C
C     + + + EXTERNALS + + +
      EXTERNAL   PMXTXD
C
      MAXLIN  = 20
      SCNINI  = 0
      DNUM    = 1
      DDVAL(1)= DVAL
      IWRT    = 0
C
      CALL PMXTXD (UMESFL,SCLU,SGRP,MAXLIN,SCNINI,IWRT,DNUM,DDVAL)
C
      RETURN
      END
C
C
C
      SUBROUTINE   PMXTXD
     I                  (UMESFL,SCLU,SGRP,MAXLIN,SCNINI,IWRT,DNUM,DVAL)
C
C     + + + PURPOSE + + +
C     This routine prints text from a message file to a terminal.
C     It fills in values from DVAL whenever delimeter is found.
C     It prompts the user every MAXLIN lines to be sure its ok
C     to continue.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER          UMESFL,SCLU,SGRP,MAXLIN,SCNINI,IWRT,DNUM
      DOUBLE PRECISION DVAL(DNUM)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     UMESFL - message file containing text to print
C     SCLU   - screen cluster number on WDM-message file
C     SGRP   - screen group number in cluster
C     MAXLIN - maximum number of lines to print before more prompt
C     SCNINI - screen initialization flag (-1 - dont clear anything,
C                                           0 - clear in EMIFE mode only
C                                           1 - always clear)
C     IWRT   - 1 - write and go, 0 - write and wait for user acknowledge
C             -1 - dont write yet (EMIFE only)
C     DNUM   - number of double precision numbers to include in message
C     DVAL   - array containing numbers to include
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I,IVAL(1),CLEN(1),ONUM,OTYP(50)
      REAL        RVAL(1)
      CHARACTER*1 CVAL(1)
C
C     + + + EXTERNALS + + +
      EXTERNAL   PMXTXM
C
C     + + + END SPECIFICATIONS + + +
C
      IVAL(1)= -999
      RVAL(1)= -999.
      CLEN(1)= 1
      CVAL(1)= ' '
      ONUM   = DNUM
      DO 10 I= 1,ONUM
        OTYP(I)= 3
 10   CONTINUE
C
      CALL PMXTXM (UMESFL,SCLU,SGRP,MAXLIN,SCNINI,ONUM,OTYP,IWRT,
     I             IVAL,RVAL,DVAL,CLEN,CVAL)
C
      RETURN
      END
C
C
C
      SUBROUTINE   PRNTXA
     I                    (UMESFL,SCLU,SGRP,CLEN,CVAL)
C
C     + + + PURPOSE + + +
C     This routine prints text from a message file to a terminal
C     with an ascii value (CVAL) of length LEN appended to the
C     end of the first line.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     UMESFL,SCLU,SGRP,CLEN
      CHARACTER*1 CVAL(CLEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     UMESFL - message file containing text to print
C     SCLU   - screen cluster number on WDM-message file
C     SGRP   - screen group number in cluster
C     CLEN   - length of character string
C     CVAL   - ascii value to append at end of first line
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   MAXLIN,SCNINI,CNUM,IWRT,ICLEN(1)
C
C     + + + EXTERNALS + + +
      EXTERNAL   PMXTXA
C
C     + + + END SPECIFICATIONS + + +
C
      MAXLIN= 20
      SCNINI= 0
      CNUM  = 1
      IWRT  = 0
      ICLEN(1)= CLEN
C
      CALL PMXTXA (UMESFL,SCLU,SGRP,MAXLIN,SCNINI,IWRT,CNUM,ICLEN,CVAL)
C
      RETURN
      END
C
C
C
      SUBROUTINE   PMXTXA
     I            (UMESFL,SCLU,SGRP,MAXLIN,SCNINI,IWRT,CNUM,CLEN,CVAL)
C
C     + + + PURPOSE + + +
C     This routine prints text from a message file to a terminal.
C     It fills in values from CVAL whenever a delimeter is found.
C     It prompts the user every MAXLIN lines to be sure its ok
C     to continue.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     UMESFL,SCLU,SGRP,MAXLIN,SCNINI,IWRT,CNUM,CLEN(CNUM)
      CHARACTER*1 CVAL(*)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     UMESFL - message file containing text to print
C     SCLU   - screen cluster number on WDM-message file
C     SGRP   - screen group number in cluster
C     MAXLIN - maximum number of lines to print before more prompt
C     SCNINI - screen initialization flag (-1 - dont clear anything,
C                                           0 - clear in EMIFE mode only
C                                           1 - always clear)
C     IWRT   - 1 - write and go, 0 - write and wait for user acknowledge
C             -1 - dont write yet (EMIFE only)
C     CNUM   - number of character strings to include in message
C     CLEN   - array of lengths of character strings
C     CVAL   - array containing character strings to include
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I,IVAL(1),ONUM,OTYP(50)
      REAL       RVAL(1)
      DOUBLE PRECISION DVAL(1)
C
C     + + + EXTERNALS + + +
      EXTERNAL   PMXTXM
C
C     + + + END SPECIFICATIONS + + +
C
      IVAL(1)= -999
      RVAL(1)= -999.
      DVAL(1)= -999.
      ONUM   = CNUM
      DO 10 I= 1,ONUM
        OTYP(I)= 4
 10   CONTINUE
C
      CALL PMXTXM (UMESFL,SCLU,SGRP,MAXLIN,SCNINI,ONUM,OTYP,IWRT,
     I             IVAL,RVAL,DVAL,CLEN,CVAL)
C
      RETURN
      END
C
C
C
      SUBROUTINE   PMXTFI
     I                   ( UMESFL, FUNIT, SCLU, SGRP, INUM, IVAL )
C
C     + + + PURPOSE + + +
C     This routine prints text form a message file to an output file.
C     It fills in values from IVAL whenever a delimeter is found.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   UMESFL, FUNIT, SCLU, SGRP, INUM, IVAL(INUM)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     UMESFL - Fortran unit number of message file containing text
C     FUNIT  - Fortran unit number of output file
C     SCLU   - screen cluster number on WDM-message file
C     SGRP   - screen group number in cluster
C     INUM   - number of integers to include in message
C     IVAL   - array containing integers to pe included in text
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   ONUM, OTYP(50), CLEN(1)
      REAL      RVAL(1)
      DOUBLE PRECISION DVAL(1)
      CHARACTER*1 CVAL(1)
C
C     + + + EXTERNALS + + +
      EXTERNAL   PMXTXF
C
C     + + + DATA INITIALIZATIONS + + +
      DATA   OTYP,  RVAL,  DVAL, CVAL, CLEN
     #     / 50*1, -999., -999.,  ' ',    1 /
C
C     + + + END SPECIFICATIONS + + +
C
      ONUM = INUM
      CALL PMXTXF ( UMESFL, FUNIT, SCLU, SGRP, ONUM, OTYP,
     I              IVAL, RVAL, DVAL, CLEN, CVAL )
C
      RETURN
      END
C
C
C
      SUBROUTINE   PMXTFR
     I                   ( UMESFL, FUNIT, SCLU, SGRP, RNUM, RVAL )
C
C     + + + PURPOSE + + +
C     This routine prints text from a message file to an output file.
C     It fills in values from RVAL whenever a delimeter is found.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   UMESFL, FUNIT, SCLU, SGRP, RNUM
      REAL      RVAL(RNUM)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     UMESFL - Fortran unit number of message file containing text
C     FUNIT  - Fortran unit number of output file
C     SCLU   - screen cluster number on WDM-message file
C     SGRP   - screen group number in cluster
C     RNUM   - number of reals to include in message
C     RVAL   - array containing reals to be included in text
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   ONUM, OTYP(50), CLEN(1), IVAL(1)
      DOUBLE PRECISION DVAL(1)
      CHARACTER*1 CVAL(1)
C
C     + + + EXTERNALS + + +
      EXTERNAL   PMXTXF
C
C     + + + DATA INITIALIZATIONS + + +
      DATA   OTYP, IVAL,  DVAL, CVAL, CLEN
     #     / 50*2,  999, -999.,  ' ',    1 /
C
C     + + + END SPECIFICATIONS + + +
C
      ONUM = RNUM
      CALL PMXTXF ( UMESFL, FUNIT, SCLU, SGRP, ONUM, OTYP,
     I              IVAL, RVAL, DVAL, CLEN, CVAL )
C
      RETURN
      END
C
C
C
      SUBROUTINE   PMXTFC
     I                   ( UMESFL, FUNIT, SCLU, SGRP, CNUM, CLEN, CVAL )
C
C     + + + PURPOSE + + +
C     This routine prints text from a message file to an output file.
C     It fills in values from CVAL whenever a delimeter is found.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   UMESFL, FUNIT, SCLU, SGRP, CNUM, CLEN(CNUM)
      CHARACTER*1 CVAL(*)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     UMESFL - Fortran unit number of message file containing text
C     FUNIT  - Fortran unit number of output file
C     SCLU   - screen cluster number on WDM-message file
C     SGRP   - screen group number in cluster
C     CNUM   - number of characters to include in message
C     CLEN   - array of lengths of character strings
C     CVAL   - array containing characters to be included in text
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   ONUM, OTYP(50), IVAL(1)
      REAL      RVAL(1)
      DOUBLE PRECISION DVAL(1)
C
C     + + + EXTERNALS + + +
      EXTERNAL   PMXTXF
C
C     + + + DATA INITIALIZATIONS + + +
      DATA   OTYP, IVAL,  RVAL,  DVAL
     #     / 50*4,  999, -999., -999. /
C
C     + + + END SPECIFICATIONS + + +
C
      ONUM = CNUM
      CALL PMXTXF ( UMESFL, FUNIT, SCLU, SGRP, ONUM, OTYP,
     I              IVAL, RVAL, DVAL, CLEN, CVAL )
C
      RETURN
      END
C
C
C
      SUBROUTINE   PMXTXF
     I                   ( UMESFL, FUNIT, SCLU, SGRP,
     I                     ONUM, OTYP, IVAL, RVAL, DVAL, CLEN, CVAL )
C
C     + + + PURPOSE + + +
C     This routine prints text from a message file to a user file.  It
C     fills in values from IVAL, RVAL, DVAL, and CVAL arrays whenever
C     a delimeter is found.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   UMESFL, FUNIT, SCLU, SGRP, ONUM, OTYP(ONUM),
     #          IVAL(*), CLEN(*)
      REAL      RVAL(*)
      DOUBLE PRECISION DVAL(*)
      CHARACTER*1 CVAL(*)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     UMESFL - Fortran unit number of user's message file
C     FUNIT  - Fortran unit number of output file
C     SCLU   - screen cluster number on WDM-message file
C     SGRP   - screen group number in cluster
C     ONUM   - number of variables to be added to the text
C     OTYP   - array of types for variables to be added to text
C     IVAL   - array containing integer values to include
C     RVAL   - array containing real values to include
C     DVAL   - array containing double precision values to include
C     CLEN   - array of lengths of character strings to include
C     CVAL   - array of character strings to include
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I132,OPOS,DONFG,CONT,INITFG,OLEN,
     >          ICNT,RCNT,DCNT,CCNT,OCNT,LEN
      CHARACTER*1 DELIM(1), TXT(132)
C
C     + + + FUNCTIONS + + +
      INTEGER   LENSTR
C
C     + + + EXTERNALS + + +
      EXTERNAL  LENSTR, TXMULT, PRTSTR, WMSGTT
C
C     + + + END SPECIFICATIONS + + +
C
      I132 = 132
      OCNT = 1
      OPOS = 1
      DONFG= 0
      ICNT = 1
      RCNT = 1
      DCNT = 1
      CCNT = 1
      DELIM(1)= '&'
C
      INITFG= 1
 10   CONTINUE
C       get next record of text
        OLEN= I132
        CALL WMSGTT (UMESFL,SCLU,SGRP,INITFG,
     M               OLEN,
     O               TXT,CONT)
        INITFG= 0
C       replace delimeters with values to be printed
        CALL TXMULT (ONUM,OTYP,IVAL,RVAL,DVAL,CLEN,CVAL,DELIM,I132,
     M               OCNT,ICNT,RCNT,DCNT,CCNT,OPOS,TXT,CONT,
     O               DONFG)
C
C       print this part of the text
        LEN = LENSTR (I132,TXT)
        IF (LEN.EQ.0) LEN= 1
        CALL PRTSTR (FUNIT,LEN,TXT)
      IF (CONT.EQ.1) GO TO 10
C
      RETURN
      END
C
C
C
      SUBROUTINE   PMXTXM
     I                   (UMESFL,SCLU,SGRP,MAXLIN,SCNINI,ONUM,OTYP,IWRT,
     I                    IVAL,RVAL,DVAL,CLEN,CVAL)
C
C     + + + PURPOSE + + +
C     This routine prints text from a message file to a terminal.
C     It fills in values from the IVAL, RVAL, DVAL and CVAL arrays
C     whenever a delimeter is found.  It prompts the user every
C     MAXLIN lines to be sure its ok to continue.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     UMESFL,SCLU,SGRP,MAXLIN,SCNINI,ONUM,OTYP(ONUM),
     1            IWRT,IVAL(*),CLEN(*)
      REAL        RVAL(*)
      DOUBLE PRECISION DVAL(*)
      CHARACTER*1 CVAL(*)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     UMESFL - Fortran unit number for WDM file
C     SCLU   - screen cluster number on WDM-message file
C     SGRP   - screen group number in cluster
C     MAXLIN - maximum number of lines to print before more prompt
C     SCNINI - screen initialization flag (-1 - dont clear anything,
C                                           0 - clear in EMIFE mode only
C                                           1 - always clear)
C     ONUM   - number of variables to be added to the text
C     OTYP   - array of types for variables to be added to the text
C     IWRT   - 1 - write and go, 0 - write and wait for user acknowledge
C             -1 - dont write yet (EMIFE only)
C     IVAL   - array containing integers to include
C     RVAL   - array containing reals to include
C     DVAL   - array containing double precisions to include
C     CLEN   - array of lengths of character strings
C     CVAL   - array containing character strings to include
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I,I1,I78,CONT,OPOS,OLEN,ICNT,RCNT,
     1            DCNT,CCNT,OCNT,DONFG,LWRT,LINIT,INITFG
      CHARACTER*1 DELIM(1),TXT(78)
C
C     + + + FUNCTIONS + + +
      INTEGER     LENSTR
C
C     + + + EXTERNALS + + +
      EXTERNAL    LENSTR, TXMULT, WMSGTT, ZBLDWR
C
C     + + + END SPECIFICATIONS + + +
C
      I1    = 1
      I78   = 78
      OCNT  = 1
      OPOS  = 1
      DONFG = 0
      ICNT  = 1
      RCNT  = 1
      DCNT  = 1
      CCNT  = 1
      DELIM(1)= '&'
C
      IF (SCNINI.GE.0) THEN
C       initialize the menu for EMIFE screen
        LINIT= 1
      ELSE
C       dont initialize menu for EMIFE
        LINIT= 0
      END IF
C
      INITFG= 1
 10   CONTINUE
C       get next record of text
        OLEN= I78
        CALL WMSGTT (UMESFL,SCLU,SGRP,INITFG,
     M               OLEN,
     O               TXT,CONT)
        INITFG= 0
C
C       look for delimeter within string to be printed
        CALL TXMULT (ONUM,OTYP,IVAL,RVAL,DVAL,CLEN,CVAL,DELIM,I78,
     M               OCNT,ICNT,RCNT,DCNT,CCNT,OPOS,TXT,CONT,
     O               DONFG)
C
C       print this part of the line
        I= LENSTR (I78,TXT)
C       build output screen
        IF (CONT.EQ.1) THEN
C         building screen
          LWRT= -1
        ELSE
C         screen complete
          LWRT= IWRT
        END IF
        IF (I.EQ.0) I= 1
        CALL ZBLDWR (I,TXT,LINIT,LWRT,
     O               DONFG)
C       dont initialize next time through
        LINIT= 0
C
      IF (CONT.EQ.1) GO TO 10
C
      RETURN
      END
C
C
C
      SUBROUTINE   TXMULT
     I                   (ONUM, OTYP, IVAL, RVAL, DVAL, CLEN, CVAL,
     I                    DELIM, ILEN,
     M                    OCNT, ICNT, RCNT, DCNT, CCNT, OPOS, TXT, CONT,
     O                    DONFG )
C
C     + + + PURPOSE + + +
C     This routine fills in values from the IVAL, RVAL, DVAL, and
C     CVAL arrays whenever a delimeter is found in TXT.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   ONUM, OTYP(ONUM), IVAL(*), CLEN(*), ILEN,
     #          OCNT, ICNT, RCNT, DCNT, CCNT, OPOS, CONT, DONFG
      REAL      RVAL(*)
      DOUBLE PRECISION DVAL(*)
      CHARACTER*1 DELIM(1), TXT(ILEN), CVAL(*)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     ONUM   - number of variables to be output in text buffer
C     OTYP   - array of variable types
C     IVAL   - array of integer variables
C     RVAL   - array of real variables
C     DVAL   - array of double precision variables
C     CLEN   - array of character variable lengths
C     CVAL   - array of character variables
C     DELIM  - character indicating where variable are to be placed in text
C     OCNT   - current count of variables output in text buffer
C     ICNT   - current count of integer variables output
C     RCNT   - current count of real variables output
C     DCNT   - current count of double precision variables output
C     CCNT   - current count of character variables output
C     OPOS   - position within character array of next character variable
C     TXT    - current text buffer line
C     CONT   - continue outputing text flag,
C              0 - do not continue, 1 - continue
C     DONFG  - flag indicating all variables put in text,
C              0 - not all variables in text, 1 - all variables in text
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   K, I1, JX, OLEN, JUST, J, IPOS
      REAL      RTMP
      DOUBLE PRECISION DTMP
      CHARACTER*1 CTMP(78), CNONE(6), BLNK(1)
C
C     + + + FUNCTIONS + + +
      INTEGER   STRFND
C
C     + + + INTRINSICS + + +
      INTRINSIC   ABS
C
C     + + + EXTERNALS + + +
      EXTERNAL   STRFND, INTCHR, DECCHR, DPRCHR, CHRCHR, CHRDEL, CHRINS
      EXTERNAL   ZIPC
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  I1, BLNK, CNONE
     #    /  1,  ' ', '(','n','o','n','e',')' /
C
C     + + + END SPECIFICATIONS + + +
C
      DONFG = 0
 20   CONTINUE
        K= STRFND(ILEN,TXT,I1,DELIM(1))
        IF (K.GT.0) THEN
C         found delimeter
          IF (DONFG.EQ.0) THEN
C           replace with next value
            IF (OTYP(OCNT).EQ.1) THEN
C             integer value
              IF (IVAL(ICNT).NE.-999) THEN
C               put number to write into buffer
                OLEN= 14
                JUST= 1
                CALL INTCHR (IVAL(ICNT),OLEN,JUST,
     O                       J,CTMP)
              ELSE
C               put none into buffer
                J= 6
                CALL CHRCHR (J,CNONE,CTMP)
              END IF
              ICNT= ICNT+ 1
            ELSE IF (OTYP(OCNT).EQ.2) THEN
C             real value
              RTMP= ABS(RVAL(RCNT)+999)
              IF (RTMP.GT.1.0E-5) THEN
C               put number to write into buffer
                OLEN= 14
                JUST= 1
                CALL DECCHR (RVAL(RCNT),OLEN,JUST,
     O                       J,CTMP)
              ELSE
C               put none into buffer
                J= 6
                CALL CHRCHR (J,CNONE,CTMP)
              END IF
              RCNT= RCNT+ 1
            ELSE IF (OTYP(OCNT).EQ.3) THEN
C             double precision value
              DTMP= ABS(DVAL(DCNT)+999)
              IF (DTMP.GT.1.0E-5) THEN
C               put number to write into buffer
                OLEN= 14
                JUST= 1
                CALL DPRCHR (DVAL(DCNT),OLEN,JUST,
     O                       J,CTMP)
              ELSE
C               put none into buffer
                J= 6
                CALL CHRCHR (J,CNONE,CTMP)
              END IF
              DCNT= DCNT+ 1
            ELSE IF (OTYP(OCNT).EQ.4) THEN
C             character value
              J= CLEN(CCNT)
              CALL CHRCHR (J,CVAL(OPOS),CTMP)
              OPOS= OPOS+ CLEN(CCNT)
              CCNT= CCNT+ 1
            END IF
            CALL CHRDEL (ILEN,K,TXT(1))
            DO 30 JX= 1,J
              IPOS= K+ JX- 1
              IF (IPOS.LE.78) THEN
C               there's room to insert character
                CALL CHRINS (ILEN,IPOS,CTMP(JX),TXT)
              END IF
 30         CONTINUE
            OCNT= OCNT+ 1
            IF (OCNT.GT.ONUM) THEN
              DONFG= 1
            END IF
          ELSE
C           delimeter found, but no more values, clear rest of line
            CALL ZIPC (ILEN-K+1,BLNK,TXT(K))
            IF (K.EQ.1) THEN
C             stop printing
              CONT= 0
            END IF
          END IF
        END IF
      IF (DONFG.EQ.0.AND.K.GT.0) GO TO 20
C
      RETURN
      END
