C     qtscn1.f 2.1 9/4/91
C
C
C
      SUBROUTINE   QRESPM
     I                   (UMESFL,SCLU,SGRP,INUM,RNUM,CNUM,
     M                    IVAL,RVAL,CVAL,
     O                    TBUFF)
C
C     + + + PURPOSE + + +
C     This routine prompts a user for a response that contains any
C     combination of integer, decimal and character strings.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     UMESFL,SCLU,SGRP,INUM,RNUM,CNUM
      REAL        RVAL(RNUM)
      INTEGER     IVAL(INUM),CVAL(CNUM,3)
      CHARACTER*1 TBUFF(80)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     UMESFL - Fortran unit number of users message file
C     SCLU   - screen cluster number on WDM-message file
C     SGRP   - screen group number in cluster
C     INUM   - number or integer responses
C     RNUM   - number of real responses
C     CNUM   - number of character responses
C     IVAL   - array containing integer responses, calling routine
C              may pass initial values
C     RVAL   - array containing real responses, calling routine may
C              pass initial values
C     CVAL   - array containing information about character responses
C              (_,1) - response sequence number
C              (_,2) - starting position of character response in TBUFF
C              (_,3) - length of character response
C     TBUFF  - character string containing integer, real, and character
C              responses in the order described by the message file
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I
      CHARACTER*1 BLNK
C
C     + + + EXTERNALS + + +
      EXTERNAL   QRESPX, ZIPC
C
C     + + + DATA INITIALIZATIONS + + +
      DATA BLNK /' '/
C
C     + + + END SPECIFICATIONS + + +
C
      I= 80
      CALL ZIPC (I,BLNK,TBUFF)
C
      CALL QRESPX (UMESFL,SCLU,SGRP,INUM,RNUM,CNUM,
     M             IVAL,RVAL,CVAL,TBUFF)
C
      RETURN
      END
C
C
C
      SUBROUTINE   QRESPX
     I                   (UMESFL,SCLU,SGRP,INUM,RNUM,CNUM,
     M                    IVAL,RVAL,CVAL,TBUFF)
C
C     + + + PURPOSE + + +
C     This routine prompts a user for a response that contains any
C     combination of integer, decimal and character strings.  Uses
C     existing TBUFF for initial values.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     UMESFL,SCLU,SGRP,INUM,RNUM,CNUM
      REAL        RVAL(RNUM)
      INTEGER     IVAL(INUM),CVAL(CNUM,3)
      CHARACTER*1 TBUFF(80)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     UMESFL - Fortran unit number of users message file
C     SCLU   - screen cluster number on WDM-message file
C     SGRP   - screen group number in cluster
C     INUM   - number or integer responses
C     RNUM   - number of real responses
C     CNUM   - number of character responses
C     IVAL   - array containing integer responses, calling routine
C              may pass initial values
C     RVAL   - array containing real responses, calling routine may
C              pass initial values
C     CVAL   - array containing information about character responses
C              (_,1) - response sequence number
C              (_,2) - starting position of character response in TBUFF
C              (_,3) - length of character response
C     TBUFF  - character string containing integer, real, and character
C              responses in the order described by the message file,
C              calling program may pass initial values
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     NROW,SCNFG
C
C     + + + EXTERNALS + + +
      EXTERNAL   QRESCX
C
C     + + + END SPECIFICATIONS + + +
C
      NROW = 1
      SCNFG= 0
C
      CALL QRESCX (UMESFL,SCLU,SGRP,INUM,RNUM,CNUM,NROW,SCNFG,
     M             IVAL,RVAL,CVAL,TBUFF)
C
      RETURN
      END
C
C
C
      SUBROUTINE   QRESCN
     I                   (UMESFL,SCLU,SGRP,INUM,RNUM,CNUM,NROW,SCNFG,
     M                    IVAL,RVAL,CVAL,TBUFF)
C
C     + + + PURPOSE + + +
C     This routine prompts a user for a response that contains any
C     combination of integer, decimal and character strings.  May
C     be called with many rows of data and used in screen mode.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     UMESFL,SCLU,SGRP,INUM,RNUM,CNUM,NROW,SCNFG
      REAL        RVAL(RNUM,NROW)
      INTEGER     IVAL(INUM,NROW),CVAL(CNUM,3,NROW)
      CHARACTER*1 TBUFF(80,NROW)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     UMESFL - Fortran unit number of users message file
C     SCLU   - screen cluster number on WDM-message file
C     SGRP   - screen group number in cluster
C     INUM   - number or integer responses
C     RNUM   - number of real responses
C     CNUM   - number of character responses
C     NROW   - number or rows of responses
C     SCNFG  - indicator flag for type of input processing
C              0 - process one line at a time
C              1 - process a screen at a time
C     IVAL   - array containing integer responses, calling routine
C              may pass initial values
C     RVAL   - array containing real responses, calling routine may
C              pass initial values
C     CVAL   - array containing information about character responses
C              (_,1) - response sequence number
C              (_,2) - starting position of character response in TBUFF
C              (_,3) - length of character response
C     TBUFF  - array of character strings containing integer, real, and
C              character responses in the order described by the
C              message file
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I
      CHARACTER*1 BLNK
C
C     + + + EXTERNALS + + +
      EXTERNAL   ZIPC, QRESCX
C
C     + + + END SPECIFICATIONS + + +
C
      BLNK= ' '
      I= NROW* 80
      CALL ZIPC(I,BLNK,TBUFF)
      CALL QRESCX
     I            (UMESFL,SCLU,SGRP,INUM,RNUM,CNUM,NROW,SCNFG,
     M             IVAL,RVAL,CVAL,TBUFF)
C
      RETURN
      END
C
C
C
      SUBROUTINE   QRESCX
     I                   (UMESFL,SCLU,SGRP,INUM,RNUM,CNUM,NROW,SCNFG,
     M                    IVAL,RVAL,CVAL,TBUFF)
C
C     + + + PURPOSE + + +
C     This routine prompts a user for a response that contains any
C     combination of integer, decimal and character strings.  Uses
C     existing TBUFF for initial values.  May be called with many
C     rows of data and used in screen mode.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     UMESFL,SCLU,SGRP,INUM,RNUM,CNUM,NROW,SCNFG
      REAL        RVAL(RNUM,NROW)
      INTEGER     IVAL(INUM,NROW),CVAL(CNUM,3,NROW)
      CHARACTER*1 TBUFF(80,NROW)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     UMESFL - Fortran unit number of users message file
C     SCLU   - screen cluster number on WDM-message file
C     SGRP   - screen group number in cluster
C     INUM   - number or integer responses
C     RNUM   - number of real responses
C     CNUM   - number of character responses
C     NROW   - number or rows of responses
C     SCNFG  - indicator flag for type of input processing
C              0 - process one line at a time
C              1 - process a screen at a time
C     IVAL   - array containing integer responses, calling routine
C              may pass initial values
C     RVAL   - array containing real responses, calling routine may
C              pass initial values
C     CVAL   - array containing information about character responses
C              (_,1) - response sequence number
C              (_,2) - starting position of character response in TBUFF
C              (_,3) - length of character response
C     TBUFF  - array of character strings containing integer, real, and
C              character responses in the order described by the
C              message file
C
C     + + + LOCAL VARIABLES + + +
      INTEGER            DNUM
      DOUBLE PRECISION   DVAL(1)
C
C     + + + EXTERNALS + + +
      EXTERNAL   QRESCR
C
C     + + + END SPECIFICATIONS + + +
C
      DNUM= 1
C
      CALL QRESCR (UMESFL,SCLU,SGRP,INUM,RNUM,DNUM,CNUM,NROW,SCNFG,
     M             IVAL,RVAL,DVAL,CVAL,TBUFF)
C
      RETURN
      END
C
C
C
      SUBROUTINE   QRESCD
     I                   (MESSFL,SCLU,SGRP,INUM,RNUM,DNUM,CNUM,
     I                    NROW,SCNFG,
     M                    IVAL,RVAL,DVAL,CVAL,TBUFF)
C
C     + + + PURPOSE + + +
C     This routine prompts a user for a response that contains any
C     combination of integer, decimal, double precision, and character
C     strings.  May be called with many rows of data and used in
C     screen mode.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     MESSFL,SCLU,SGRP,INUM,RNUM,DNUM,CNUM,NROW,SCNFG
      REAL        RVAL(RNUM,NROW)
      INTEGER     IVAL(INUM,NROW),CVAL(CNUM,3,NROW)
      CHARACTER*1 TBUFF(80,NROW)
      DOUBLE PRECISION DVAL(DNUM,NROW)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of users message file
C     SCLU   - screen cluster number on WDM-message file
C     SGRP   - screen group number in cluster
C     INUM   - number or integer responses
C     RNUM   - number of real responses
C     DNUM   - number of double precision responses
C     CNUM   - number of character responses
C     NROW   - number or rows of responses
C     SCNFG  - indicator flag for type of input processing
C              0 - process one line at a time
C              1 - process a screen at a time
C     IVAL   - array containing integer responses, calling routine
C              may pass initial values
C     RVAL   - array containing real responses, calling routine may
C              pass initial values
C     DVAL   - array containing double precision responses, calling
C              routine may pass initial values
C     CVAL   - array containing information about character responses
C              (_,1) - response sequence number
C              (_,2) - starting position of character response in TBUFF
C              (_,3) - length of character response
C     TBUFF  - array of character strings containing integer, real, and
C              character responses in the order described by the
C              message file
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      I
      CHARACTER* 1 BK(1)
C
C     + + + EXTERNALS + + +
      EXTERNAL   ZIPC, QRESCR
C
C     + + + END SPECIFICATIONS + + +
C
      BK(1)= ' '
      I= 80 * NROW
      CALL ZIPC (I,BK(1),TBUFF)
C
      CALL QRESCR (MESSFL,SCLU,SGRP,INUM,RNUM,DNUM,CNUM,NROW,SCNFG,
     M             IVAL,RVAL,DVAL,CVAL,TBUFF)
C
      RETURN
      END
C
C
C
      SUBROUTINE   QRESCR
     I                   (UMESFL,SCLU,SGRP,INUM,RNUM,DNUM,CNUM,
     I                    NROW,SCNFG,
     M                    IVAL,RVAL,DVAL,CVAL,TBUFF)
C
C     + + + PURPOSE + + +
C     This routine prompts a user for a response that contains any
C     combination of integer, decimal, double precision, and character
C     strings.  Uses existing TBUFF for initial values.  May be called
C     with many rows of data and used in screen mode.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     UMESFL,SCLU,SGRP,INUM,RNUM,DNUM,CNUM,NROW,SCNFG
      REAL        RVAL(RNUM,NROW)
      INTEGER     IVAL(INUM,NROW),CVAL(CNUM,3,NROW)
      CHARACTER*1 TBUFF(80,NROW)
      DOUBLE PRECISION DVAL(DNUM,NROW)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     UMESFL - Fortran unit number of users message file
C     SCLU   - screen cluster number on WDM-message file
C     SGRP   - screen group number in cluster
C     INUM   - number or integer responses
C     RNUM   - number of real responses
C     DNUM   - number of double precision responses
C     CNUM   - number of character responses
C     NROW   - number or rows of responses
C     SCNFG  - indicator flag for type of input processing
C              0 - process one line at a time
C              1 - process a screen at a time
C     IVAL   - array containing integer responses, calling routine
C              may pass initial values
C     RVAL   - array containing real responses, calling routine may
C              pass initial values
C     DVAL   - array containing double precision responses, calling
C              routine may pass initial values
C     CVAL   - array containing information about character responses
C              (_,1) - response sequence number
C              (_,2) - starting position of character response in TBUFF
C              (_,3) - length of character response
C     TBUFF  - array of character strings containing integer, real, and
C              character responses in the order described by the
C              message file
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    TLEN
C
C     + + + EXTERNALS + + +
      EXTERNAL   QRESCZ
C
C     + + + END SPECIFICATIONS + + +
C
      TLEN= 80
      CALL QRESCZ (UMESFL,SCLU,SGRP,INUM,RNUM,DNUM,CNUM,
     I             NROW,SCNFG,TLEN,
     M             IVAL,RVAL,DVAL,CVAL,TBUFF)
C
      RETURN
      END
C
C
C
      SUBROUTINE   QRESCZ
     I                   (UMESFL,SCLU,SGRP,INUM,RNUM,DNUM,CNUM,
     I                    NROW,SCNFG,TLEN,
     M                    IVAL,RVAL,DVAL,CVAL,TBUFF)
C
C     + + + PURPOSE + + +
C     This routine prompts a user for a response that contains any
C     combination of integer, decimal, double precision, and character
C     strings.  Uses existing TBUFF for initial values.  May be called
C     with many rows of data and used in screen mode.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     UMESFL,SCLU,SGRP,INUM,RNUM,DNUM,CNUM,NROW,SCNFG,TLEN
      REAL        RVAL(RNUM,NROW)
      INTEGER     IVAL(INUM,NROW),CVAL(CNUM,3,NROW)
      CHARACTER*1 TBUFF(TLEN,NROW)
      DOUBLE PRECISION DVAL(DNUM,NROW)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     UMESFL - Fortran unit number of users message file
C     SCLU   - screen cluster number on WDM-message file
C     SGRP   - screen group number in cluster
C     INUM   - number or integer responses
C     RNUM   - number of real responses
C     DNUM   - number of double precision responses
C     CNUM   - number of character responses
C     NROW   - number or rows of responses
C     SCNFG  - indicator flag for type of input processing
C              0 - process one line at a time
C              1 - process a screen at a time
C     TLEN   - length of character buffer string
C     IVAL   - array containing integer responses, calling routine
C              may pass initial values
C     RVAL   - array containing real responses, calling routine may
C              pass initial values
C     DVAL   - array containing double precision responses, calling
C              routine may pass initial values
C     CVAL   - array containing information about character responses
C              (_,1) - response sequence number
C              (_,2) - starting position of character response in TBUFF
C              (_,3) - length of character response
C     TBUFF  - array of character strings containing integer, real, and
C              character responses in the order described by the
C              message file
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CSCREN.INC'
      INCLUDE 'ZCNTRL.INC'
C     INCLUDE 'COLOR.INC'
C     INCLUDE 'CQRSP.INC'
C
C     + + + PARAMETERS + + +
      INCLUDE 'PMESFL.INC'
C     INCLUDE 'PMXERR.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I,J,K,L,I1,I78,LSCLU,LSGRP,LROW,ERRFLG,IND,IRET,
     1            LCOL(30),LLIN(30),IPOS,CLASS,NLIN,ILIN,SGLCHR
C
C     + + + FUNCTIONS + + +
      INTEGER     LENSTR
C
C     + + + INTRINSICS + + +
C     INTRINSIC   MOD
C
C     + + + EXTERNALS + + +
      EXTERNAL    LENSTR, PRNTXT, CHRCHR, WMSGTP, ZIPI
      EXTERNAL    ZEDIT1, ZSCDEF, ZFLOUT, ZEDT0M, ZFILVL
C
C     + + + END SPECIFICATIONS + + +
C
      SGLCHR = 0
      I1 = 1
      I78= 78
C     screen cluster for general messages
      LSCLU= 4
C
      IF (NROW.EQ.0) THEN
C       error, full screen wont work, print message
        LSGRP= 89
        CALL PRNTXT (MESSFL,LSCLU,LSGRP)
      ELSE
C       ok to do full screen
 150    CONTINUE
          CALL WMSGTP (UMESFL,SCLU,SGRP,CLASS,ERRFLG)
          CALL ZSCDEF (INUM,RNUM,CNUM,DNUM,NROW,
     M                 IVAL,RVAL,DVAL,CVAL)
          CALL ZIPI (NFLDS,I1,LLIN)
          IPOS= 1
          DO 200 I= 1,NFLDS
            LCOL(I)= IPOS
            IPOS= IPOS+ FLEN(I)
 200      CONTINUE
C
          IF (LENSTR(TLEN,TBUFF(1,1)).GT.0) THEN
C           put TBUFF values in data arrays
            CALL ZFILVL (CLASS,NROW,TLEN,TBUFF,NROW,
     I                   INUM,RNUM,DNUM,CNUM,NFLDS,LCOL,FLEN,
     I                   LLIN,FTYP,FDVAL,CCNT,RSPSTR,APOS,
     O                   IVAL,RVAL,DVAL,CVAL)
          END IF
C         put data arrays in screen text
          CALL ZFLOUT (CLASS,INUM,RNUM,DNUM,CNUM,NROW,TLEN,
     M                 TBUFF,LCOL,IVAL,RVAL,DVAL,CVAL)
          IF (CLASS.EQ.1) THEN
C           PRM1 type screen
            CALL ZEDT0M (SGLCHR,
     O                   IRET)
            NLIN= ZMNNLI
            ILIN= 1
          ELSE IF (CLASS.EQ.2) THEN
C           PRM2 type screen
            CALL ZEDIT1 (NROW,
     O                   IRET)
            NLIN= NROW
            ILIN= NMHDRW+ 1
          END IF
        IF (IRET.EQ.-1) GO TO 150
        CALL ZFILVL (CLASS,NLIN,I78,ZMNTX1(1,ILIN),NROW,
     I               INUM,RNUM,DNUM,CNUM,NFLDS,SCOL,FLEN,
     I               FLIN,FTYP,FDVAL,CCNT,RSPSTR,APOS,
     O               IVAL,RVAL,DVAL,CVAL)
        DO 400 I= 1,NFLDS
C         put values back in TBUFF
          J= SCOL(I)
          K= LCOL(I)
          DO 300 LROW= 1,NROW
            IF (CLASS.EQ.1) THEN
              L= FLIN(I)
            ELSE IF (CLASS.EQ.2) THEN
C             PRM2 type screen
              L= NMHDRW+ LROW
            END IF
            CALL CHRCHR (FLEN(I),ZMNTX1(J,L),TBUFF(K,LROW))
 300      CONTINUE
 400    CONTINUE
C       fill in CVAL with lengths and locations of responses.
        DO 940 I =1,NFLDS
          IND= APOS(I)
          IF (FTYP(I).EQ.FTC.AND.IND.LE.CNUM) THEN
C           fill in rest of CVAL
            DO 930 CROW= 1, NROW
              CVAL(IND,2,CROW) = LCOL(I)
              CVAL(IND,3,CROW) = FLEN(I)
 930        CONTINUE
          END IF
 940    CONTINUE
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   COLINI
C
C     + + + PURPOSE + + +
C     This routine initializes the colors to be used in the program
C
C     + + + COMMON BLOCK + + +
      INCLUDE 'COLOR.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I,PRMIND
C
C     + + + INTRINSICS + + +
C     (none)
C
C     + + + EXTERNALS + + +
      EXTERNAL   COLSET, ANPRGT
C
C     + + + END SPECIFICATIONS + + +
C
C     assign colors from TERM.DAT or default
      DO 10 I=1,13
        PRMIND= I+ 21
        CALL ANPRGT (PRMIND,COLARR(I))
 10   CONTINUE
C
C     set to standard colors to start
      CALL COLSET (FRS,BKS)
C
      RETURN
      END
C
C
C
      SUBROUTINE   QSCSET
     I                    (INUM,RNUM,DNUM,CNUM,NMFLDS,UIMIN,UIMAX,UIDEF,
     I                     URMIN,URMAX,URDEF,UDMIN,UDMAX,UDDEF,
     I                     VLINFG,UCCNT,UCDEF,USTRLN,URSPST)
C
C     + + + PURPOSE + + +
C     routine to set common block values for full screen limits as
C     definied by user (bypassing assignment from message file)
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     INUM,RNUM,DNUM,CNUM,NMFLDS
      INTEGER     UIMIN(INUM),UIMAX(INUM),UIDEF(INUM),VLINFG(NMFLDS),
     1            UCCNT(NMFLDS),UCDEF(CNUM),USTRLN(NMFLDS)
      REAL        URMIN(RNUM),URMAX(RNUM),URDEF(RNUM)
      DOUBLE PRECISION UDMIN(DNUM),UDMAX(DNUM),UDDEF(DNUM)
      CHARACTER*1 URSPST(960)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     INUM   - number of integer fields
C     RNUM   - number of real fields
C     DNUM   - number of double precision fields
C     CNUM   - number of character fields
C     NMFLDS - number of fields for this screen
C     UIMIN  - array of user-defined integer minimum values
C     UIMAX  - array of user-defined integer maximum values
C     UIDEF  - array of user-defined integer default values
C     URMIN  - array of user-defined real minimum values
C     URMAX  - array of user-defined real maximum values
C     URDEF  - array of user-defined real default values
C     UDMIN  - array of user-defined double precision minimum values
C     UDMAX  - array of user-defined double precision maximum values
C     UDDEF  - array of user-defined double precision default values
C     VLINFG - valid/invalid flag, 1- valid, 2- invalid, (0- none)
C     UCCNT  - array of user-defined valid responses for each field
C     UCDEF  - array of user-defined default responses for character fields
C     USTRLN - array of user-defined lengths of responses
C     URSPST - user-defined string of valid responses
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CSCREN.INC'
      INCLUDE 'ZCNTRL.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I,RSPOS,RSLEN
C
C     + + + FUNCTIONS + + +
      INTEGER    WMSPIV
C
C     + + + EXTERNALS + + +
      EXTERNAL   WMSPIV, CHRCHR
C
C     + + + END SPECIFICATIONS + + +
C
C     set screen parameters init flag to 'on'
      SPINIT= 1
C
      DO 10 I= 1,INUM
        IMIN(I)= UIMIN(I)
        IMAX(I)= UIMAX(I)
        IDEF(I)= UIDEF(I)
 10   CONTINUE
C
      DO 20 I= 1,RNUM
        RMIN(I)= URMIN(I)
        RMAX(I)= URMAX(I)
        RDEF(I)= URDEF(I)
 20   CONTINUE
C
      DO 30 I= 1,DNUM
        DMIN(I)= UDMIN(I)
        DMAX(I)= UDMAX(I)
        DDEF(I)= UDDEF(I)
 30   CONTINUE
C
      DO 40 I= 1,CNUM
        IF (UCDEF(I).GT.0) THEN
C         set default only, valid/invalid set below
          CDEF(I)= UCDEF(I)
        END IF
 40   CONTINUE
C
      RSPOS= 1
      DO 50 I= 1,NMFLDS
C       set valid/invalid responses for all type fields
        IF (VLINFG(I).GT.0) THEN
C         valid/invalid responses exist for this field
          CCNT(I)= UCCNT(I)
          RSLEN  = UCCNT(I)* USTRLN(I)
          IF (VLINFG(I).EQ.1) THEN
C           valid responses, default?
            FDVAL(I)= WMSPIV(RSPOS,RSLEN)
          ELSE
C           invalid responses
            FDINV(I)= WMSPIV(RSPOS,RSLEN)
          END IF
          CALL CHRCHR (RSLEN,URSPST(RSPOS),RSPSTR(RSPOS))
          RSPOS= RSPOS+ RSLEN
        ELSE
C         no valid/invalid responses for this field
          FDVAL(I)= 0
          FDINV(I)= 0
        END IF
 50   CONTINUE
C
      RETURN
      END
C
C
C
      SUBROUTINE   QUESET
     I                    (UQUEST)
C
C     + + + PURPOSE + + +
C     routine to set common block value for full screen question
C     as defined by user (bypassing assignment from message file)
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*1 UQUEST(78)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     UQUEST - user defined question for full screen
C
C     + + + COMMON BLOCK + + +
      INCLUDE 'CQRSP.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I
C
C     + + + EXTERNALS + + +
      EXTERNAL   CHRCHR
C
C     + + + END SPECIFICATIONS + + +
C
C     set question initialized flag to on
      QUINIT= 1
C
C     put user defined question into common block question
      I= 78
      CALL CHRCHR (I,UQUEST,QUEST)
C
      RETURN
      END
C
C
C
      SUBROUTINE   HLPSET
     I                   (MESSFL,SCLU,SGRP,CLASS)
C
C     + + + PURPOSE + + +
C     set help for a screen from a cluster besides the
C     one for that screen
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL,SCLU,SGRP,CLASS
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number for message file
C     SCLU   - cluster containing help message
C     SGRP   - group containing help message
C     CLASS  - type of screen containing help message
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'ZCNTRL.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    ID,DREC,DPOS
C
C     + + + FUNCTIONS + + +
      INTEGER    WDPTCL
C
C     + + + EXTERNALS + + +
      EXTERNAL   WDPTCL, WMSIDP, ZSTCMA
C
C     + + + END SPECIFICATIONS + + +
C
      IF (CLASS.EQ.1 .OR. CLASS.EQ.2) THEN
        ID= 15
      ELSE IF (CLASS.EQ.3) THEN
        ID= 2
      ELSE IF (CLASS.EQ.4 .OR. CLASS.EQ.5) THEN
        ID= 6
      END IF
C     get record and offset for start of help information
      CALL WMSIDP (MESSFL,SCLU,SGRP,ID,
     O             DREC,DPOS)
C     store record and offset in pointer to help info
      GPTR= WDPTCL (DREC,DPOS)
      IF (GPTR.GT.0) THEN
C       increment parameter init flag to indicate help is set
        HPINIT= 1
C       make help available
        CALL ZSTCMA (1,1)
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   INITM
     I                   (INUM, RNUM, CNUM,
     O                    IVAL, RVAL, CVAL)
C
C     + + + PURPOSE + + +
C     Initialize the integer, real, and character arguments
C     for full screen calls (QRESPM, QRESPX, QRESCN, QRESCX).
C     Minimum number for each type of response is 1.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   INUM, RNUM, CNUM
      INTEGER   IVAL(INUM), CVAL(CNUM,3)
      REAL      RVAL(RNUM)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     INUM   - number of integer responses (minimum of 1)
C     RNUM   - number of real responses (minimum of 1)
C     CNUM   - number of character responses (minimum of 1)
C     IVAL   - array for integer responses of size INUM
C     RVAL   - array for real responses of size RNUM
C     CVAL   - array for information about character
C              responses of size CNUM,3
C              (_,1) - response sequence number
C              (_,2) - starting position of character
C                      response in buffer of responses
C              (_,3) - length of character response
C
C     + + + LOCAL VARIABLES + + +
      INTEGER          DNUM
      DOUBLE PRECISION DVAL(1)
C
C     + + + EXTERNALS + + +
      EXTERNAL   INITMD
C
C     + + + END SPECIFICATIONS + + +
C
      DNUM= 1
C
      CALL INITMD (INUM,RNUM,DNUM,CNUM,
     O             IVAL,RVAL,DVAL,CVAL)
C
      RETURN
      END
C
C
C
      SUBROUTINE   INITMD
     I                    (INUM, RNUM, DNUM, CNUM,
     O                     IVAL, RVAL, DVAL, CVAL)
C
C     + + + PURPOSE + + +
C     Initialize the integer, real, double precision, and
C     character arguments for full screen calls (QRESCR, QRESCD,
C     QRESCZ).  Minimum number for each type of response is 1.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   INUM, RNUM, DNUM, CNUM
      INTEGER   IVAL(INUM), CVAL(CNUM,3)
      REAL      RVAL(RNUM)
      DOUBLE PRECISION  DVAL(DNUM)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     INUM   - number of integer responses (minimum of 1)
C     RNUM   - number of real responses (minimum of 1)
C     DNUM   - number of double precision responses (minimum of 1)
C     CNUM   - number of character responses (minimum of 1)
C     IVAL   - array for integer responses of size INUM
C     RVAL   - array for real responses of size RNUM
C     DVAL   - array for double precision responses of size DNUM
C     CVAL   - array for information about character
C              responses of size CNUM,3
C              (_,1) - response sequence number
C              (_,2) - starting position of character
C                      response in buffer of responses
C              (_,3) - length of character response
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    IZIP, CZIP
      REAL       RZIP
      DOUBLE PRECISION DZIP
C
C     + + + EXTERNALS + + +
      EXTERNAL   ZIPI, ZIPR, ZIPD
C
C     + + + DATA INITIALIZATIONS + + +
      DATA  IZIP, CZIP, RZIP, DZIP
     *     /-999,    1, -999., -999. /
C
C     + + + END SPECIFICATIONS + + +
C
      IF (INUM .GT. 0) CALL ZIPI ( INUM, IZIP, IVAL )
      IF (RNUM .GT. 0) CALL ZIPR ( RNUM, RZIP, RVAL )
      IF (DNUM .GT. 0) CALL ZIPD ( DNUM, DZIP, DVAL )
      IF(CNUM .GT. 0) THEN
        CALL ZIPI( CNUM, CZIP, CVAL(1,1) )
        CALL ZIPI( CNUM, CZIP, CVAL(1,2) )
        CALL ZIPI( CNUM, CZIP, CVAL(1,3) )
      END IF
C
      RETURN
      END
