C
C
C
      SUBROUTINE   QSETI
     I                  (INUM,IVAL)
C
C     + + + PURPOSE + + +
C     Set the values for integer fields
C     on a data screen prior to editing.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   INUM,IVAL(INUM)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     INUM   - number of integer fields for which to set values
C     IVAL   - array of integer values
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I
C
C     + + + EXTERNALS + + +
      EXTERNAL   QSETIB
C
C     + + + END SPECIFICATIONS + + +
C
      I= 1
      CALL QSETIB (INUM,I,IVAL)
C
      RETURN
      END
C
C
C
      SUBROUTINE   QSETIB
     I                   (INUM,IBAS,IVAL)
C
C     + + + PURPOSE + + +
C     Set the values for integer fields
C     on a data screen prior to editing.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   INUM,IBAS,IVAL(INUM)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     INUM   - number of integer fields for which to set values
C     IBAS   - base position within integer fields to begin setting values
C     IVAL   - array of integer values
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CSCREN.INC'
      INCLUDE 'ZCNTRL.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     J,JUST,NODAT,IFLD,LFLD,IBSCNT,IPOS,ILEN
      CHARACTER*1 CNONE(4)
C
C     + + + EXTERNALS + + +
      EXTERNAL   CHRCHR, INTCHR
C
C     + + + DATA INITIALIZATIONS + + +
      DATA CNONE/'n','o','n','e'/
C
C     + + + END SPECIFICATIONS + + +
C
      JUST = 0
      NODAT= -999
C
      LFLD= 0
      IFLD= 0
      IBSCNT= 0
 100  CONTINUE
C       need to look through all fields to find the integer ones
        LFLD= LFLD+ 1
        IF (FTYP(LFLD).EQ.FTI) THEN
C         integer field found
          IFLD= IFLD+ 1
          IF (IFLD.GE.IBAS) THEN
C           start setting values
            IBSCNT= IBSCNT+ 1
            IF (IVAL(IBSCNT).EQ.0 .OR. IVAL(IBSCNT).EQ.NODAT) THEN
C             no initial value, set field to default
              IVAL(IBSCNT)= IDEF(IFLD)
            END IF
            IF (IVAL(IBSCNT).EQ.NODAT) THEN
C             no value use "NONE".
              IF (FLEN(LFLD).GT.4) THEN
C               push 'none' to right side of field
                IPOS= SCOL(LFLD)+ FLEN(LFLD)- 4
                ILEN= 4
              ELSE
C               just start 'none' in 1st position of field
                IPOS= SCOL(LFLD)
                ILEN= FLEN(LFLD)
              END IF
              CALL CHRCHR (ILEN,CNONE,
     O                     ZMNTX1(IPOS,FLIN(LFLD)))
            ELSE
C             put current value in text
              CALL INTCHR (IVAL(IBSCNT),FLEN(LFLD),JUST,
     O                     J,ZMNTX1(SCOL(LFLD),FLIN(LFLD)))
            END IF
          END IF
        END IF
      IF (LFLD.LT.NFLDS .AND. IBSCNT.LT.INUM) GO TO 100
C
      RETURN
      END
C
C
C
      SUBROUTINE   QGETI
     I                  (INUM,
     O                   IVAL)
C
C     + + + PURPOSE + + +
C     Get the values for integer fields
C     on a data screen after editing.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   INUM,IVAL(INUM)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     INUM   - number of integer fields for which to get values
C     IVAL   - array of integer values
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I
C
C     + + + EXTERNALS + + +
      EXTERNAL   QGETIB
C
C     + + + END SPECIFICATIONS + + +
C
      I= 1
      CALL QGETIB (INUM,I,
     O             IVAL)
C
      RETURN
      END
C
C
C
      SUBROUTINE   QGETIB
     I                   (INUM,IBAS,
     O                    IVAL)
C
C     + + + PURPOSE + + +
C     Get the values for integer fields
C     on a data screen after editing.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   INUM,IBAS,IVAL(INUM)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     INUM   - number of integer fields for which to get values
C     IBAS   - base position within integer fields to begin getting values
C     IVAL   - array of integer values
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CSCREN.INC'
      INCLUDE 'ZCNTRL.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I,J,I4,IFLD,LFLD,ILEN,NODAT,IBSCNT
      CHARACTER*1 CNONE(4)
C
C     + + + FUNCTIONS + + +
      INTEGER     STRFND, LENSTR, CRINTX
C
C     + + + EXTERNALS + + +
      EXTERNAL    STRFND, LENSTR, CRINTX, ZLJUST
C
C     + + + DATA INITIALIZATIONS + + +
      DATA CNONE/'n','o','n','e'/
C
C     + + + END SPECIFICATIONS + + +
C
      I4   = 4
      NODAT= -999
C
      IFLD= 0
      LFLD= 0
      IBSCNT= 0
 100  CONTINUE
C       need to look through all fields to find the integer ones
        LFLD= LFLD+ 1
        IF (FTYP(LFLD).EQ.FTI) THEN
C         integer field found
          IFLD= IFLD+ 1
          IF (IFLD.GE.IBAS) THEN
C           start getting values
            IBSCNT= IBSCNT+ 1
            I= SCOL(LFLD)
            J= SCOL(LFLD)+ FLEN(LFLD)- 1
            CALL ZLJUST (ZMNTXT(FLIN(LFLD))(I:J))
            IF (STRFND(FLEN(LFLD),ZMNTX1(I,FLIN(LFLD)),
     1                                          I4,CNONE).GT.0) THEN
C             current field is 'none', set value to -999
              IVAL(IBSCNT)= NODAT
            ELSE
C             convert value in text to variable
              ILEN= LENSTR(FLEN(LFLD),ZMNTX1(I,FLIN(LFLD)))
              IF (ILEN .GT. 0) THEN
                IVAL(IBSCNT)= CRINTX (ILEN,ZMNTX1(I,FLIN(LFLD)))
              ELSE
                IVAL(IBSCNT) = NODAT
              END IF
            END IF
          END IF
        END IF
      IF (LFLD.LT.NFLDS .AND. IBSCNT.LT.INUM) GO TO 100
C
      RETURN
      END
C
C
C
      SUBROUTINE   QSETR
     I                  (RNUM,RVAL)
C
C     + + + PURPOSE + + +
C     Set the values for real fields
C     on a data screen prior to editing.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   RNUM
      REAL      RVAL(RNUM)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     RNUM   - number of real fields for which to set values
C     RVAL   - array of real values
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I
C
C     + + + EXTERNALS + + +
      EXTERNAL   QSETRB
C
C     + + + END SPECIFICATIONS + + +
C
      I= 1
      CALL QSETRB (RNUM,I,RVAL)
C
      RETURN
      END
C
C
C
      SUBROUTINE   QSETRB
     I                   (RNUM,RBAS,RVAL)
C
C     + + + PURPOSE + + +
C     Set the values for real fields
C     on a data screen prior to editing.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   RNUM,RBAS
      REAL      RVAL(RNUM)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     RNUM   - number of real fields for which to set values
C     RBAS   - base position within real fields to begin setting values
C     RVAL   - array of real values
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CSCREN.INC'
      INCLUDE 'ZCNTRL.INC'
C     numeric constants
      INCLUDE 'CONST.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     J,JUST,RFLD,LFLD,RBSCNT,ILEN,IPOS
      REAL        NODAT
      CHARACTER*1 CNONE(4)
C
C     + + + INTRINSICS + + +
      INTRINSIC   ABS
C
C     + + + EXTERNALS + + +
      EXTERNAL   CHRCHR, DECCHR
C
C     + + + DATA INITIALIZATIONS + + +
      DATA CNONE/'n','o','n','e'/
C
C     + + + END SPECIFICATIONS + + +
C
      JUST = 0
      NODAT= -999.0
C
      LFLD= 0
      RFLD= 0
      RBSCNT= 0
 100  CONTINUE
C       need to look through all fields to find the real ones
        LFLD= LFLD+ 1
        IF (FTYP(LFLD).EQ.FTR) THEN
C         real field found
          RFLD= RFLD+ 1
          IF (RFLD.GE.RBAS) THEN
C           start setting values
            RBSCNT= RBSCNT+ 1
            IF (ABS(RVAL(RBSCNT)).LT.R0MIN .OR.
     1          ABS(RVAL(RBSCNT)-NODAT).LT.R0MIN) THEN
C             no current value, use default
              RVAL(RBSCNT)= RDEF(RFLD)
            END IF
            IF (ABS(RVAL(RBSCNT)-NODAT).LT.R0MIN) THEN
C             no value use "NONE".
              IF (FLEN(LFLD).GT.4) THEN
C               push 'none' to right side of field
                IPOS= SCOL(LFLD)+ FLEN(LFLD)- 4
                ILEN= 4
              ELSE
C               just start 'none' in 1st position of field
                IPOS= SCOL(LFLD)
                ILEN= FLEN(LFLD)
              END IF
              CALL CHRCHR (ILEN,CNONE,
     O                     ZMNTX1(IPOS,FLIN(LFLD)))
            ELSE
C             put current value in text
              CALL DECCHR (RVAL(RBSCNT),FLEN(LFLD),JUST,
     O                     J,ZMNTX1(SCOL(LFLD),FLIN(LFLD)))
            END IF
          END IF
        END IF
      IF (LFLD.LT.NFLDS .AND. RBSCNT.LT.RNUM) GO TO 100
C
      RETURN
      END
C
C
C
      SUBROUTINE   QGETR
     I                  (RNUM,
     O                   RVAL)
C
C     + + + PURPOSE + + +
C     Get the values for real fields
C     on a data screen after editing.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   RNUM
      REAL      RVAL(RNUM)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     RNUM   - number of real fields for which to get values
C     RVAL   - array of real values
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I
C
C     + + + EXTERNALS + + +
      EXTERNAL   QGETRB
C
C     + + + END SPECIFICATIONS + + +
C
      I= 1
      CALL QGETRB (RNUM,I,
     O             RVAL)
C
      RETURN
      END
C
C
C
      SUBROUTINE   QGETRB
     I                   (RNUM,RBAS,
     O                    RVAL)
C
C     + + + PURPOSE + + +
C     Get the values for real fields
C     on a data screen after editing.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   RNUM,RBAS
      REAL      RVAL(RNUM)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     RNUM   - number of real fields for which to get values
C     RBAS   - base position within real fields to begin getting values
C     RVAL   - array of real values
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CSCREN.INC'
      INCLUDE 'ZCNTRL.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I,J,I4,RFLD,LFLD,ILEN,RBSCNT
      REAL        NODAT
      CHARACTER*1 CNONE(4)
C
C     + + + FUNCTIONS + + +
      INTEGER     STRFND, LENSTR
      REAL        CHRDEC
C
C     + + + EXTERNALS + + +
      EXTERNAL    STRFND, LENSTR, CHRDEC, ZLJUST
C
C     + + + DATA INITIALIZATIONS + + +
      DATA CNONE/'n','o','n','e'/
C
C     + + + END SPECIFICATIONS + + +
C
      I4   = 4
      NODAT= -999.0
C
      RFLD= 0
      LFLD= 0
      RBSCNT= 0
 100  CONTINUE
C       need to look through all fields to find the integer ones
        LFLD= LFLD+ 1
        IF (FTYP(LFLD).EQ.FTR) THEN
C         real field found
          RFLD= RFLD+ 1
          IF (RFLD.GE.RBAS) THEN
C           start getting values
            RBSCNT= RBSCNT+ 1
            I= SCOL(LFLD)
            J= SCOL(LFLD)+ FLEN(LFLD)- 1
            CALL ZLJUST (ZMNTXT(FLIN(LFLD))(I:J))
            IF (STRFND(FLEN(LFLD),ZMNTX1(I,FLIN(LFLD)),
     1                                    I4,CNONE).GT.0) THEN
C             current value is 'none', set to -999.
              RVAL(RBSCNT)= NODAT
            ELSE
C             convert value in text to variable
              ILEN= LENSTR(FLEN(LFLD),ZMNTX1(I,FLIN(LFLD)))
              IF (ILEN .GT. 0) THEN
                RVAL(RBSCNT)= CHRDEC(ILEN,ZMNTX1(I,FLIN(LFLD)))
              ELSE
                RVAL(RBSCNT) = NODAT
              END IF
            END IF
          END IF
        END IF
      IF (LFLD.LT.NFLDS .AND. RBSCNT.LT.RNUM) GO TO 100
C
      RETURN
      END
C
C
C
      SUBROUTINE   QSETD
     I                  (DNUM,DVAL)
C
C     + + + PURPOSE + + +
C     Set the values for double precision fields
C     on a data screen prior to editing.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   DNUM
      DOUBLE PRECISION DVAL(DNUM)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DNUM   - number of double precision fields for which to set values
C     DVAL   - array of double precision values
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I
C
C     + + + EXTERNALS + + +
      EXTERNAL   QSETDB
C
C     + + + END SPECIFICATIONS + + +
C
      I= 1
      CALL QSETDB (DNUM,I,DVAL)
C
      RETURN
      END
C
C
C
      SUBROUTINE   QSETDB
     I                   (DNUM,DBAS,DVAL)
C
C     + + + PURPOSE + + +
C     Set the values for double precision fields
C     on a data screen prior to editing.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   DNUM,DBAS
      DOUBLE PRECISION DVAL(DNUM)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DNUM   - number of double precision fields for which to set values
C     DBAS   - base position within db. prec. fields to begin setting values
C     DVAL   - array of double precision values
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CSCREN.INC'
      INCLUDE 'ZCNTRL.INC'
C     numeric constants
      INCLUDE 'CONST.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     J,JUST,DFLD,LFLD,DBSCNT,ILEN,IPOS
      DOUBLE PRECISION NODAT
      CHARACTER*1 CNONE(4)
C
C     + + + INTRINSICS + + +
      INTRINSIC   ABS
C
C     + + + EXTERNALS + + +
      EXTERNAL   CHRCHR, DPRCHR
C
C     + + + DATA INITIALIZATIONS + + +
      DATA CNONE/'n','o','n','e'/
C
C     + + + END SPECIFICATIONS + + +
C
      JUST = 0
      NODAT= -999.0
C
      LFLD= 0
      DFLD= 0
      DBSCNT= 0
 100  CONTINUE
C       need to look through all fields to find the real ones
        LFLD= LFLD+ 1
        IF (FTYP(LFLD).EQ.FTD) THEN
C         double precision field found
          DFLD= DFLD+ 1
          IF (DFLD.GE.DBAS) THEN
C           start setting values
            DBSCNT= DBSCNT+ 1
            IF (ABS(DVAL(DBSCNT)).LT.D0MIN .OR.
     1          ABS(DVAL(DBSCNT)-NODAT).LT.D0MIN) THEN
C             no current value, use default
              DVAL(DBSCNT)= DDEF(DFLD)
            END IF
            IF (ABS(DVAL(DBSCNT)-NODAT).LT.D0MIN) THEN
C             no value use "NONE"
              IF (FLEN(LFLD).GT.4) THEN
C               push 'none' to right side of field
                IPOS= SCOL(LFLD)+ FLEN(LFLD)- 4
                ILEN= 4
              ELSE
C               just start 'none' in 1st position of field
                IPOS= SCOL(LFLD)
                ILEN= FLEN(LFLD)
              END IF
              CALL CHRCHR (ILEN,CNONE,
     O                     ZMNTX1(IPOS,FLIN(LFLD)))
            ELSE
C             put current value in text
              CALL DPRCHR (DVAL(DBSCNT),FLEN(LFLD),JUST,
     O                     J,ZMNTX1(SCOL(LFLD),FLIN(LFLD)))
            END IF
          END IF
        END IF
      IF (LFLD.LT.NFLDS .AND. DBSCNT.LT.DNUM) GO TO 100
C
      RETURN
      END
C
C
C
      SUBROUTINE   QGETD
     I                  (DNUM,
     O                   DVAL)
C
C     + + + PURPOSE + + +
C     Get the values for double precision fields
C     on a data screen after editing.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   DNUM
      DOUBLE PRECISION DVAL(DNUM)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DNUM   - number of double precision fields for which to get values
C     DVAL   - array of double precision values
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I
C
C     + + + EXTERNALS + + +
      EXTERNAL   QGETDB
C
C     + + + END SPECIFICATIONS + + +
C
      I= 1
      CALL QGETDB (DNUM,I,
     O             DVAL)
C
      RETURN
      END
C
C
C
      SUBROUTINE   QGETDB
     I                   (DNUM,DBAS,
     O                    DVAL)
C
C     + + + PURPOSE + + +
C     Get the values for real fields
C     on a data screen after editing.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   DNUM,DBAS
      DOUBLE PRECISION DVAL(DNUM)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DNUM   - number of double precision fields for which to get values
C     DBAS   - base position within db. prec. fields to begin getting values
C     DVAL   - array of double precision values
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CSCREN.INC'
      INCLUDE 'ZCNTRL.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I,J,I4,DFLD,LFLD,ILEN,DBSCNT
      DOUBLE PRECISION NODAT
      CHARACTER*1 CNONE(4)
C
C     + + + FUNCTIONS + + +
      INTEGER     STRFND, LENSTR
      DOUBLE PRECISION    CHRDPR
C
C     + + + EXTERNALS + + +
      EXTERNAL    STRFND, LENSTR, CHRDPR, ZLJUST
C
C     + + + DATA INITIALIZATIONS + + +
      DATA CNONE/'n','o','n','e'/
C
C     + + + END SPECIFICATIONS + + +
C
      I4   = 4
      NODAT= -999.0
C
      DFLD= 0
      LFLD= 0
      DBSCNT= 0
 100  CONTINUE
C       need to look through all fields to find the double precision ones
        LFLD= LFLD+ 1
        IF (FTYP(LFLD).EQ.FTD) THEN
C         double precision field found
          DFLD= DFLD+ 1
          IF (DFLD.GE.DBAS) THEN
C           start getting values
            DBSCNT= DBSCNT+ 1
            I= SCOL(LFLD)
            J= SCOL(LFLD)+ FLEN(LFLD)- 1
            CALL ZLJUST (ZMNTXT(FLIN(LFLD))(I:J))
            IF (STRFND(FLEN(LFLD),ZMNTX1(I,FLIN(LFLD)),
     1                                          I4,CNONE).GT.0) THEN
C             current value is 'none', set to -999.
              DVAL(DBSCNT)= NODAT
            ELSE
C             convert value in text to variable
              ILEN= LENSTR(FLEN(LFLD),ZMNTX1(I,FLIN(LFLD)))
              IF (ILEN .GT. 0) THEN
                DVAL(DBSCNT)= CHRDPR(ILEN,ZMNTX1(I,FLIN(LFLD)))
              ELSE
                DVAL(DBSCNT) = NODAT
              END IF
            END IF
          END IF
        END IF
      IF (LFLD.LT.NFLDS .AND. DBSCNT.LT.DNUM) GO TO 100
C
      RETURN
      END
C
C
C
      SUBROUTINE   QSETCO
     I                   (CNUM,CVAL)
C
C     + + + PURPOSE + + +
C     Set the values for character fields with valid
C     responses on a data screen prior to editing.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   CNUM,CVAL(CNUM)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CNUM   - number of character fields for which to set values
C     CVAL   - array of character order values
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I
C
C     + + + EXTERNALS + + +
      EXTERNAL   QSTCOB
C
C     + + + END SPECIFICATIONS + + +
C
      I= 1
      CALL QSTCOB (CNUM,I,CVAL)
C
      RETURN
      END
C
C
C
      SUBROUTINE   QSTCOB
     I                   (CNUM,CBAS,CVAL)
C
C     + + + PURPOSE + + +
C     Set the values for character fields with valid
C     responses on a data screen prior to editing.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   CNUM,CBAS,CVAL(CNUM)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CNUM   - number of character fields for which to set values
C     CBAS   - base position within character fields to begin setting values
C     CVAL   - array of character order values
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CSCREN.INC'
      INCLUDE 'ZCNTRL.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     IPOS,ILEN,NODAT,TFLD,LFLD,TBSCNT
      CHARACTER*1 CNONE(4)
C
C     + + + EXTERNALS + + +
      EXTERNAL    CHRCHR, WMSPIS, ZIPC
C
C     + + + DATA INITIALIZATIONS + + +
      DATA CNONE/'n','o','n','e'/
C
C     + + + END SPECIFICATIONS + + +
C
      NODAT= -999
C
      LFLD= 0
      TFLD= 0
      TBSCNT= 0
 100  CONTINUE
C       need to look through all fields to find the character ones
        LFLD= LFLD+ 1
        IF (FTYP(LFLD).EQ.FTC) THEN
C         character field found
          TFLD= TFLD+ 1
          IF (TFLD.GE.CBAS) THEN
C           start setting values
            TBSCNT= TBSCNT+ 1
            IF (CVAL(TBSCNT).EQ.0 .OR. CVAL(TBSCNT).EQ.NODAT) THEN
C             no current value, use default
              CVAL(TBSCNT) = CDEF(TFLD)
            END IF
            IF (CVAL(TBSCNT).NE.0 .AND. FDVAL(LFLD).NE.0) THEN
C             character with valids and current value exists
              CALL WMSPIS (FDVAL(LFLD),
     M                     IPOS,ILEN)
C             first clear out field
              CALL ZIPC (FLEN(LFLD),BLNK,ZMNTX1(SCOL(LFLD),FLIN(LFLD)))
C             now put current value in field
              IPOS= IPOS+ (CVAL(TBSCNT)-1)* FLEN(LFLD)
              CALL CHRCHR (FLEN(LFLD),RSPSTR(IPOS),
     M                     ZMNTX1(SCOL(LFLD),FLIN(LFLD)))
            ELSE IF (FDVAL(LFLD).NE.0) THEN
C             character with valids, no value, use 'none'
              IF (FLEN(LFLD).LT.4) THEN
                ILEN= FLEN(LFLD)
              ELSE
                ILEN= 4
              END IF
              CALL CHRCHR (ILEN,CNONE,
     M                     ZMNTX1(SCOL(LFLD),FLIN(LFLD)))
            END IF
          END IF
        END IF
      IF (LFLD.LT.NFLDS .AND. TBSCNT.LT.CNUM) GO TO 100
C
      RETURN
      END
C
C
C
      SUBROUTINE   QSETCT
     I                   (CNUM,CLEN,TLEN,CTXT)
C
C     + + + PURPOSE + + +
C     Set the values for character fields with no valid
C     responses (plain text) on a data screen prior to editing.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     CNUM,CLEN(CNUM),TLEN
      CHARACTER*1 CTXT(TLEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CNUM   - number of character fields for which to set values
C     CLEN   - array of lengths of text strings for each field
C     TLEN   - total length of character strings (sum of CLEN array)
C     CTXT   - array of character strings for each field
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I
C
C     + + + EXTERNALS + + +
      EXTERNAL   QSTCTB
C
C     + + + END SPECIFICATIONS + + +
C
      I= 1
      CALL QSTCTB (CNUM,CLEN,TLEN,I,CTXT)
C
      RETURN
      END
C
C
C
      SUBROUTINE   QSTCTF
     I                   (CIND,CLEN,CTXT)
C
C     + + + PURPOSE + + +
C     Set the value for one character field with no valid
C     responses (plain text) on a data screen prior to editing.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     CIND,CLEN
      CHARACTER*1 CTXT(CLEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CIND   - character field number for which to set value
C     CLEN   - length of text string for field
C     CTXT   - character string for field
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    TLEN,CNUM,LCLEN(1)
C
C     + + + EXTERNALS + + +
      EXTERNAL   QSTCTB
C
C     + + + END SPECIFICATIONS + + +
C
      LCLEN(1)= CLEN
      TLEN= CLEN
      CNUM= 1
      CALL QSTCTB (CNUM,LCLEN,TLEN,CIND,CTXT)
C
      RETURN
      END
C
C
C
      SUBROUTINE   QSTCTB
     I                   (CNUM,CLEN,TLEN,CBAS,CTXT)
C
C     + + + PURPOSE + + +
C     Set the values for character fields with no valid
C     responses (plain text) on a data screen prior to editing.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     CNUM,CLEN(CNUM),TLEN,CBAS
      CHARACTER*1 CTXT(TLEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CNUM   - number of character fields for which to set values
C     CLEN   - array of lengths of text strings for each field
C     TLEN   - total length of character strings (sum of CLEN array)
C     CBAS   - base field within character fields to begin setting values
C     CTXT   - array of character strings for each field
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CSCREN.INC'
      INCLUDE 'ZCNTRL.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     IPOS,ILEN,TFLD,LFLD,CPOS,CTMP,TBSCNT
C
C     + + + FUNCTIONS + + +
      INTEGER     CHKSTR
C
C     + + + EXTERNALS + + +
      EXTERNAL    CHKSTR, CHRCHR, WMSPIS
C
C     + + + END SPECIFICATIONS + + +
C
      LFLD= 0
      TFLD= 0
      CPOS= 1
      TBSCNT= 0
 100  CONTINUE
C       need to look through all fields to find the character ones
        LFLD= LFLD+ 1
        IF (FTYP(LFLD).EQ.FTC) THEN
C         character field found
          TFLD= TFLD+ 1
          IF (TFLD.GE.CBAS) THEN
C           start setting values
            TBSCNT= TBSCNT+ 1
            IF (TBSCNT.GT.1) THEN
C             determine position in supplied text string for this field
              CPOS= CPOS+ CLEN(TBSCNT-1)
            END IF
            IF (FDVAL(LFLD).GT.0) THEN
C             field has valid values, see if supplied text is one of them
              CALL WMSPIS (FDVAL(LFLD),
     O                     IPOS,ILEN)
              CTMP= CHKSTR(FLEN(LFLD),CCNT(LFLD),CTXT(CPOS),
     1                     RSPSTR(IPOS))
            ELSE
C             put supplied text in screen text
              CTMP= 1
            END IF
            IF (CTMP.GT.0) THEN
C             put supplied text in screen text
              IF (CLEN(TBSCNT).GT.FLEN(LFLD)) THEN
C               not enough room in field for supplied text, truncate
                ILEN= FLEN(LFLD)
              ELSE
                ILEN= CLEN(TBSCNT)
              END IF
              CALL CHRCHR (ILEN,CTXT(CPOS),
     M                     ZMNTX1(SCOL(LFLD),FLIN(LFLD)))
            END IF
          END IF
        END IF
      IF (LFLD.LT.NFLDS .AND. TBSCNT.LT.CNUM) GO TO 100
C
      RETURN
      END
C
C
C
      SUBROUTINE   QGETCO
     I                   (CNUM,
     O                    CVAL)
C
C     + + + PURPOSE + + +
C     Get the values for character fields with valid
C     responses on a data screen prior to editing.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   CNUM,CVAL(CNUM)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CNUM   - number of character fields for which to get values
C     CVAL   - array of character order values
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I
C
C     + + + EXTERNALS + + +
      EXTERNAL   QGTCOB
C
C     + + + END SPECIFICATIONS + + +
C
      I= 1
      CALL QGTCOB (CNUM,I,
     O             CVAL)
C
      RETURN
      END
C
C
C
      SUBROUTINE   QGTCOB
     I                   (CNUM,CBAS,
     O                    CVAL)
C
C     + + + PURPOSE + + +
C     Get the values for character fields with valid
C     responses on a data screen prior to editing.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   CNUM,CBAS,CVAL(CNUM)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CNUM   - number of character fields for which to get values
C     CBAS   - base position within character fields to begin setting values
C     CVAL   - array of character order values
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CSCREN.INC'
      INCLUDE 'ZCNTRL.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    IPOS,ILEN,TFLD,LFLD,TBSCNT
C
C     + + + FUNCTIONS + + +
      INTEGER    CHKSTR
C
C     + + + EXTERNALS + + +
      EXTERNAL   CHKSTR, LFTSTR, WMSPIS
C
C     + + + END SPECIFICATIONS + + +
C
      LFLD= 0
      TFLD= 0
      TBSCNT= 0
 100  CONTINUE
C       need to look through all fields to find the character ones
        LFLD= LFLD+ 1
        IF (FTYP(LFLD).EQ.FTC) THEN
C         character field found
          TFLD= TFLD+ 1
          IF (TFLD.GE.CBAS) THEN
C           start getting values
            TBSCNT= TBSCNT+ 1
            IF (FDVAL(LFLD).GT.0) THEN
C             character with valids and current value exists
              CALL WMSPIS (FDVAL(LFLD),
     M                     IPOS,ILEN)
              CALL LFTSTR (FLEN(LFLD),ZMNTX1(SCOL(LFLD),FLIN(LFLD)))
              CVAL(TBSCNT)= CHKSTR(FLEN(LFLD),CCNT(LFLD),
     1                      ZMNTX1(SCOL(LFLD),FLIN(LFLD)),RSPSTR(IPOS))
            ELSE
C             character without valids, no order value
              CVAL(TBSCNT)= 0
            END IF
          END IF
        END IF
      IF (LFLD.LT.NFLDS .AND. TBSCNT.LT.CNUM) GO TO 100
C
      RETURN
      END
C
C
C
      SUBROUTINE   QGETCT
     I                   (CNUM,CLEN,TLEN,
     O                    CTXT)
C
C     + + + PURPOSE + + +
C     Get the values for character fields with no valid
C     responses (plain text) on a data screen prior to editing.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     CNUM,CLEN(CNUM),TLEN
      CHARACTER*1 CTXT(TLEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CNUM   - number of character fields for which to get values
C     CLEN   - array of lengths of text strings for each field
C     TLEN   - total length of character strings (sum of CLEN array)
C     CTXT   - array of character strings for each field
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I
C
C     + + + EXTERNALS + + +
      EXTERNAL   QGTCTB
C
C     + + + END SPECIFICATIONS + + +
C
      I= 1
      CALL QGTCTB (CNUM,CLEN,TLEN,I,
     M             CTXT)
C
      RETURN
      END
C
C
C
      SUBROUTINE   QGTCTF
     I                   (CIND,CLEN,
     O                    CTXT)
C
C     + + + PURPOSE + + +
C     Get the value for one character field with no valid
C     responses (plain text) on a data screen prior to editing.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     CIND,CLEN
      CHARACTER*1 CTXT(CLEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CIND   - character field number for which to set value
C     CLEN   - length of text string for field
C     CTXT   - character string for field
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    TLEN,CNUM,LCLEN(1)
C
C     + + + EXTERNALS + + +
      EXTERNAL   QGTCTB
C
C     + + + END SPECIFICATIONS + + +
C
      LCLEN(1)= CLEN
      TLEN= CLEN
      CNUM= 1
      CALL QGTCTB (CNUM,LCLEN,TLEN,CIND,CTXT)
C
      RETURN
      END
C
C
C
      SUBROUTINE   QGTCTB
     I                   (CNUM,CLEN,TLEN,CBAS,
     O                    CTXT)
C
C     + + + PURPOSE + + +
C     Get the values for character fields with no valid
C     responses (plain text) on a data screen prior to editing.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     CNUM,CLEN(CNUM),TLEN,CBAS
      CHARACTER*1 CTXT(TLEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CNUM   - number of character fields for which to set values
C     CLEN   - array of lengths of text strings for each field
C     TLEN   - total length of character strings (sum of CLEN array)
C     CBAS   - base field within character fields to begin setting values
C     CTXT   - array of character strings for each field
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CSCREN.INC'
      INCLUDE 'ZCNTRL.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     TFLD,LFLD,CPOS,TBSCNT
C
C     + + + EXTERNALS + + +
      EXTERNAL    CHRCHR
C
C     + + + END SPECIFICATIONS + + +
C
      LFLD= 0
      TFLD= 0
      CPOS= 1
      TBSCNT= 0
 100  CONTINUE
C       need to look through all fields to find the character ones
        LFLD= LFLD+ 1
        IF (FTYP(LFLD).EQ.FTC) THEN
C         character field found
          TFLD= TFLD+ 1
          IF (TFLD.GE.CBAS) THEN
C           start getting values
            TBSCNT= TBSCNT+ 1
            IF (TBSCNT.GT.1) THEN
C             determine position in supplied text string for this field
              CPOS= CPOS+ CLEN(TBSCNT-1)
            END IF
            CALL CHRCHR (CLEN(TBSCNT),ZMNTX1(SCOL(LFLD),FLIN(LFLD)),
     O                   CTXT(CPOS))
          END IF
        END IF
      IF (LFLD.LT.NFLDS .AND. TBSCNT.LT.CNUM) GO TO 100
C
      RETURN
      END
C
C
C
      SUBROUTINE   QSETOP
     I                   (OPCNT,OPLEN,MXSEL,MNSEL,OPVAL)
C
C     + + + PURPOSE + + +
C     Set common block parameters for option type data fields
C     based on supplied arguments.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   OPCNT,OPLEN,MXSEL(OPCNT),MNSEL(OPCNT),OPVAL(OPLEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     OPCNT  - number of sets of options on screen
C     OPLEN  - total number of options which may be selected from screen
C     MXSEL  - maximum number of options which may be selected per set
C     MNSEL  - minimum number of options which may be selected per set
C     OPVAL  - array of order numbers, within sets, of selected fields
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CZOPTN.INC'
      INCLUDE 'CZHIDE.INC'
      INCLUDE 'CSCREN.INC'
      INCLUDE 'ZCNTRL.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I,J,IPOS,LFLD,LVAL
C
C     + + + EXTERNALS + + +
      EXTERNAL    ZIPI
C
C     + + + END SPECIFICATIONS + + +
C
C     init array of option fields selected to all fields OFF
      I= 0
      CALL ZIPI (OPLEN,I,OPSVAL)
C
C     set common parameters based on supplied arguments
      DO 100 I= 1,OPCNT
C       fill in min/max selections per set
        IF (MNSEL(I).GE.0 .AND. MNSEL(I).LE.MXSEL(I)) THEN
C         reasonable value
          OPMNSL(I)= MNSEL(I)
        ELSE
C         bogus value, set to default of 1
          OPMNSL(I)= 1
        END IF
        IF (MXSEL(I).GT.0 .AND. MXSEL(I).GE.MNSEL(I)) THEN
C         reasonable value
          OPMXSL(I)= MXSEL(I)
        ELSE
C         bogus value, set to default of 1
          OPMXSL(I)= 1
        END IF
C       init number of selections for this set
        CURSEL(I)= 0
C       determine position within OPVAL array
        IPOS= 0
C       also determine number of fields offset
        IF (I.GT.1) THEN
C         determine offsets
          DO 30 J= 1,I-1
            IPOS= IPOS+ OPMXSL(J)
 30       CONTINUE
        END IF
        DO 50 J= 1,MXSEL(I)
C         fill in supplied initial values
          IPOS= IPOS+ 1
          IF (OPVAL(IPOS).GT.0) THEN
C           value supplied
            OPSVAL(IPOS) = OPVAL(IPOS)
C           increment number of options selected for this set
            CURSEL(I) = CURSEL(I)+ 1
C           which field does this correspond to
            LFLD = 0
 40         CONTINUE
              LFLD= LFLD+ 1
              IF (OPSET(LFLD).EQ.I .AND.
     1            OPSTNO(LFLD).EQ.OPSVAL(IPOS)) THEN
C               this is the field, set screen text appropriately
                ZMNTX1(SCOL(LFLD),FLIN(LFLD))= 'X'
                LFLD= NFLDS+ 1
              END IF
            IF (LFLD.LT.NFLDS) GO TO 40
          END IF
 50     CONTINUE
 100  CONTINUE
C     check for any hidden fields
      IF (NUMHID.GT.0) THEN
C       some hidden fields exist
        DO 150 I= 1,NUMHID
C         see if value of 'trigger' field makes target field be hidden
          IPOS= 0
          IF (OPSET(HIDTFL(I)).GT.1) THEN
C           determine offset within option selected array
            DO 120 J= 1,OPSET(HIDTFL(I))-1
              IPOS= IPOS+ OPMXSL(J)
 120        CONTINUE
          END IF
C         look through option selected array to see if field is on or off
          LVAL= 0
          DO 130 J= 1,OPMXSL(OPSET(HIDTFL(I)))
            IF (OPSVAL(J+IPOS).EQ.OPSTNO(HIDTFL(I))) THEN
C             this field is on
              LVAL= 1
            END IF
 130      CONTINUE
          IF (HIDVAL(I).EQ.LVAL) THEN
C           set flag to indicate hide is active for this field
            HIDFLG(I)= 1
          ELSE
C           hide not active
            HIDFLG(I)= 0
          END IF
 150    CONTINUE
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   QGETOP
     I                   (OPLEN,
     O                    OPVAL)
C
C     + + + PURPOSE + + +
C     Get options selected array values from common and
C     return values in supplied argument array.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   OPLEN,OPVAL(OPLEN)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     OPLEN  - total number of options which may be selected from screen
C     OPVAL  - array of order numbers, within sets, of selected fields
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CZOPTN.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I
C
C     + + + END SPECIFICATIONS + + +
C
C     put common values of options selected array into output argument
      DO 100 I= 1,OPLEN
        OPVAL(I)= OPSVAL(I)
 100  CONTINUE
C
      RETURN
      END
